Drupal.behaviors.itoggle = {
  attach: function(context, settings) {
    var $toggle = jQuery('div.itoggle-wrapper', context);

    if ($toggle.length) {
      $toggle.once(function(){
        var $t = jQuery(this),
        id = $t.attr('data-id'),
        type = $t.attr('data-type'),
        property = $t.attr('data-property'),
        scope = $t.attr('data-scope'),
        token_key = 'itoggle_' + type + '_' + property + '_' + id,
        itoggle_settings = {
          keepLabel: false,
          easing: settings.itoggle.easing,
          speed: settings.itoggle.speed,
          onSlideOn: function(){
            if (settings.itoggle.onslideon) {
              eval(settings.itoggle.onslideon);
            }
            
            if (scope === 'field-edit') {
              var $target = jQuery(this).parent().parent().prevAll('div[id^=edit-' + property.replace(/_/g, '-') + ']:first');
              $target.find('input[type=checkbox]').attr('checked', 'checked');
            } else {
              if (settings.itoggle.clickable[token_key]) {
                var serial = 'token=' + settings.itoggle.tokens[token_key] + '&type=' + type +
                  '&property='  + property + '&id=' + id + '&value=1&scope=' + scope;

                jQuery.post(settings.basePath + 'js/itoggle', serial, function(response){
                  if (!response.ok || response.ok !== true) {
                    var $object = jQuery('label.itoggle', $t);

                    $object.animate({backgroundPosition:'100% -'+h+'px'}, settings.itoggle.speed, settings.itoggle.easing, function(){
                      $object.removeClass('iTon').addClass('iToff');
                    });
                  }
                }, 'json');
              }
            }
          },
          onSlideOff: function(){
            if (settings.itoggle.onslideoff) {
              eval(settings.itoggle.onslideoff);
            }

            if (scope === 'field-edit') {
              var $target = jQuery(this).parent().parent().prevAll('div[id^=edit-' + property.replace(/_/g, '-') + ']:first');
              $target.find('input[type=checkbox]').removeAttr('checked');
            } else {
              if (settings.itoggle.clickable[token_key]) {
                var serial = 'token=' + settings.itoggle.tokens[token_key] + '&type=' + type +
                  '&property='  + property + '&id=' + id + '&value=0&scope=' + scope;

                jQuery.post(settings.basePath + 'js/itoggle', serial, function(response){
                  if (!response.ok || response.ok !== true) {
                    var $object = jQuery('label.itoggle', $t);

                    $object.animate({backgroundPosition:'0% -'+h+'px'}, settings.speed, settings.easing, function(){
                      $object.removeClass('iToff').addClass('iTon');
                    });
                  }
                }, 'json');                
              }
            }
          }
        };
        
        if (settings.itoggle.onclick) {
          itoggle_settings.onClick = function() {
            eval(settings.itoggle.onclick);
          }
        }
        
        if (settings.itoggle.onclickon) {
          itoggle_settings.onClickOn = function() {
            eval(settings.itoggle.onclickon);
          }
        }

        if (settings.itoggle.onclickoff) {
          itoggle_settings.onClickOff = function() {
            eval(settings.itoggle.onclickoff);
          }
        }
        
        if (settings.itoggle.onslide) {
          itoggle_settings.onSlide = function() {
            eval(settings.itoggle.onslide);
          }
        }

        $t.find('input:first').iToggle(itoggle_settings);
        
        if (settings.views || !settings.itoggle.clickable[token_key]) {
          // must wait until events fully bound
          setTimeout(function(){
            $t.find('label.itoggle').unbind('click').css('cursor', 'default').find('span').css('cursor', 'default').click(function() {return false} );
          }, 100);
        }
      });
    }
  }
};